%% [MATLAB] MAIN FUNCTION
function varargout = udir_VGP_Input_dlg(varargin)
% Dialogs used for input data for VGP calculation

% Last Modified by Chuang Xuan 20-Apr-2009 12:18:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @udir_VGP_Input_dlg_OpeningFcn, ...
                   'gui_OutputFcn',  @udir_VGP_Input_dlg_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


%% [MATLAB] OPENING FUNCTION
function udir_VGP_Input_dlg_OpeningFcn(hObject, eventdata, handles, varargin)


setappdata(0, 'vgpCalcDecision', 0);
handles.output = hObject;
guidata(hObject, handles);


%% [MATLAB] OUTPUT
function varargout = udir_VGP_Input_dlg_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


%% [PUSH] CALCULATE AND DISPLAY VGP
function pushbutton_CalculateVGP_Callback(hObject, eventdata, handles)

setappdata(0, 'vgpCalcDecision'       , 1);
setappdata(0, 'vgpDeclCorr'           , str2double(get(handles.edit_DeclCorr, 'string')));          
setappdata(0, 'vgpSiteLat'            , str2double(get(handles.edit_SiteLat, 'string')));    
setappdata(0, 'vgpSiteLong'           , str2double(get(handles.edit_SiteLong, 'string')));          
setappdata(0, 'vgpMapOriginLat'       , str2double(get(handles.edit_MapOriginLat, 'string')));
setappdata(0, 'vgpMapOriginLong'      , str2double(get(handles.edit_MapOriginLong, 'string')));
setappdata(0, 'vgpMapLatLim'          , str2num(get(handles.edit_MapLimitLat, 'string')));
setappdata(0, 'vgpMapLongLim'         , str2num(get(handles.edit_MapLimitLong, 'string')));

MapString = get(handles.popupmenu_MapProjection, 'String');
MapValue  = get(handles.popupmenu_MapProjection, 'Value');
setappdata(0, 'vgpMapProjectionValue' , MapValue); 
setappdata(0, 'vgpMapProjection'      , MapString{MapValue}); 

close(gcf);


%% [PUSH] ABORT VGP CALCULATION
function pushbutton_AbortCalc_Callback(hObject, eventdata, handles)

setappdata(0, 'vgpCalcDecision', 0);
close(gcf);



%% [PUSH] USE DEFAULT VALUES
function pushbutton_DefaultValues_Callback(hObject, eventdata, handles)

set(handles.edit_DeclCorr,      'String','0');
set(handles.edit_SiteLat,       'String','53.113');
set(handles.edit_SiteLong,       'String','-33.53');
set(handles.edit_MapOriginLat,  'String','0');
set(handles.edit_MapOriginLong, 'String','0');
set(handles.edit_MapLimitLat,   'String','[-90 90]');
set(handles.edit_MapLimitLong,  'String','[-180 180]');
set(handles.popupmenu_MapProjection, 'Value', 1);


%% [POPUPMENU] MAP PROJECTION
function popupmenu_MapProjection_Callback(hObject, eventdata, handles)


mapstring = get(handles.popupmenu_MapProjection, 'string');
selectedmap = mapstring(get(handles.popupmenu_MapProjection, 'value'));
if strcmp(selectedmap, 'hammer'),
   set(handles.edit_MapOriginLat, 'string', '0');
   set(handles.edit_MapOriginLong, 'string', '0');
   set(handles.edit_MapLimitLat, 'string', '[-90 90]');
   set(handles.edit_MapLimitLong, 'string', '[-180 180]'); 
elseif strcmp(selectedmap, 'globe'),
   set(handles.edit_MapOriginLat, 'string', '0');
   set(handles.edit_MapOriginLong, 'string', '0');
   set(handles.edit_MapLimitLat, 'string', 'N/A');
   set(handles.edit_MapLimitLong, 'string', 'N/A');
elseif strcmp(selectedmap, 'stereo'),
   set(handles.edit_MapOriginLat, 'string', '90');
   set(handles.edit_MapOriginLong, 'string', '0');
   set(handles.edit_MapLimitLat, 'string', '[0 90]');
   set(handles.edit_MapLimitLong, 'string', '[-180 180]');
end   
   

function popupmenu_MapProjection_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'Value', getappdata(0, 'vgpMapProjectionValue'));
end


%% [EDITS]
function edit_MapLimitLat_Callback(hObject, eventdata, handles)
function edit_MapLimitLat_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', ['[', num2str(getappdata(0, 'vgpMapLatLim')),']']);
end


function edit_MapLimitLong_Callback(hObject, eventdata, handles)
function edit_MapLimitLong_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', ['[', num2str(getappdata(0, 'vgpMapLongLim')),']']);
end


function edit_MapOriginLat_Callback(hObject, eventdata, handles)
function edit_MapOriginLat_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', num2str(getappdata(0, 'vgpMapOriginLat')));
end


function edit_MapOriginLong_Callback(hObject, eventdata, handles)
function edit_MapOriginLong_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', num2str(getappdata(0, 'vgpMapOriginLong')));
end


function edit_SiteLat_Callback(hObject, eventdata, handles)
function edit_SiteLat_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', num2str(getappdata(0, 'vgpSiteLat')));
end


function edit_SiteLong_Callback(hObject, eventdata, handles)
function edit_SiteLong_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', num2str(getappdata(0, 'vgpSiteLong')));
end


function edit_DeclCorr_Callback(hObject, eventdata, handles)
function edit_DeclCorr_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
if getappdata(0, 'vgpDefaultInput') == 0, 
   set(hObject, 'String', num2str(getappdata(0, 'vgpDeclCorr')));
end
